[Two Sum II] (https://leetcode.com/problems/two-sum-ii-input-array-is-sorted/#/description)

Problem

Given an array of integers that is already sorted in ascending order, find two numbers such that they add up to a specific target number.

The function twoSum should return indices of the two numbers such that they add up to the target, where index1 must be less than index2. Please note that your returned answers (both index1 and index2) are not zero-based.

You may assume that each input would have exactly one solution and you may not use the same element twice.

Input: numbers={2, 7, 11, 15}, target=9
Output: index1=1, index2=2

Solution

public class Solution {
    public int[] twoSum(int[] nums, int target) {
        int i = 0, j = nums.length - 1;
        while (nums[i] + nums[j] != target) {
            if (nums[i] + nums[j] < target) i++;
            else j--;
        }
        return new int[] {i + 1, j + 1};
    }
}

Analysis

Since the input array is already sorted, we can use two pointers to get the result easily
Typical solution using two pointers, nothing much to explain

Complexity

  • Time: O(n), while statement will be executed n / 2 times in worse case
  • Space: O(1), only constant space is used

results matching ""

    No results matching ""